from PropertyType import PropertyType

class PhysicalPropertyType (PropertyType) :
   __slots__ = ('name', 'size1', 'size2')
   
class IntType (PhysicalPropertyType) :
   DefaultName = "int"
   def __init__(self, _size1, _size2):
      if (_size1 == None):
         raise AssertionError, "Invalid size"
      self.name = "int"
      self.size1 = _size1
      self.size2 = None

class VarcharType (PhysicalPropertyType) :
   DefaultName = "varchar"
   def __init__(self, _size1, _size2):
      if (_size1 == None):
         raise AssertionError, "Invalid size"
      self.name = "varchar"
      self.size1 = _size1
      self.size2 = None

class CharType (PhysicalPropertyType) :
   DefaultName = "char"
   def __init__(self, _size1, _size2):
      if (_size1 == None):
         raise AssertionError, "Invalid size"
      self.name = "char"
      self.size1 = _size1
      self.size2 = None

class TimestampType (PhysicalPropertyType) :
   DefaultName = "tipestamp"
   def __init__(self, _size1, _size2):
      self.name = "timestamp"
      self.size1 = None
      self.size2 = None

class DecimalType (PhysicalPropertyType) :
    DefaultName = "decimal"
    def __init__(self, _size1, _size2):
        if (_size1 == None):
            raise AssertionError, "Invalid size"
        self.name = "decimal"
        self.size1 = _size1
        self.size2 = _size2

class FloatType (PhysicalPropertyType) :
    DefaultName = "float"
    def __init__(self, _size1, _size2):
        if (_size1 == None):
            raise AssertionError, "Invalid size"
            self.name = "float"
            self.size1 = _size1
            self.size2 = _size2

class BlobType (PhysicalPropertyType) :
    DefaultName = "blob"
    def __init__(self, _size1, _size2):
        self.name = "blob"
        self.size1 = None
        self.size2 = None


types = [IntType, VarcharType, CharType, TimestampType, DecimalType, FloatType, BlobType]

def FindType(name):
    for i in types:
        if(i.DefaultName == name):
            return i
    return None