create table ZIP( 
	ZIPCode varchar(16) not null,
	CityID int(4) not null
);
alter table ZIP add primary key (ZIPCode);
create table Customer( 
	CustomerID int(4) not null,
	CustomerName varchar(254) not null unique,
	AddressID int(4) not null,
	PhoneID int(4)
);
alter table Customer add primary key (CustomerID);
create table Address( 
	AddressID int(4) not null,
	Street varchar(254) not null,
	ZIPCode varchar(16) not null
);
alter table Address add primary key (AddressID);
create table City( 
	CityID int(4) not null,
	CityName varchar(64) not null unique,
	RegionID int(2) not null
);
alter table City add primary key (CityID);
create table Region( 
	RegionID int(2) not null,
	RegionName varchar(32) not null unique
);
alter table Region add primary key (RegionID);
create table Phone( 
	PhoneID int(4) not null,
	PhoneNo varchar(32) not null unique,
	PhoneTypeID int(1) not null
);
alter table Phone add primary key (PhoneID);
create table ContactPerson( 
	CustomerID int(4) not null,
	PersonID int(4) not null
);
alter table ContactPerson add primary key (CustomerID, PersonID);
create table Person( 
	PersonID int(4) not null,
	PersonChristianName varchar(254) not null,
	PersonFamilyName varchar(254) not null,
	PersonTitle varchar(4),
	PhoneID int(4),
	AddressID int(4),
	PersonAge decimal(5, 2),
	PersonPicture blob
);
alter table Person add primary key (PersonID);
create table PhoneType( 
	PhoneTypeID int(1) not null,
	PhoneTypeName varchar(16) not null unique
);
alter table PhoneType add primary key (PhoneTypeID);
alter table City add foreign key  (RegionID) references Region (RegionID);
alter table ZIP add foreign key  (CityID) references City (CityID);
alter table Address add foreign key  (ZIPCode) references ZIP (ZIPCode);
alter table Customer add foreign key  (AddressID) references Address (AddressID);
alter table Customer add foreign key  (PhoneID) references Phone (PhoneID);
alter table Person add foreign key  (AddressID) references Address (AddressID);
alter table Person add foreign key  (PhoneID) references Phone (PhoneID);
alter table ContactPerson add foreign key  (CustomerID) references Customer (CustomerID);
alter table ContactPerson add foreign key  (PersonID) references Person (PersonID);
alter table Phone add foreign key  (PhoneTypeID) references PhoneType (PhoneTypeID);
